#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>

struct PCX_header {
 char	manuf;
 char	hard;
 char	encode;
 char	bitpx;
 int	x1,y1,x2,y2;
 int	hres,vres;
 char	clrma[48];
 char	vmode;
 char	nplanes;
 int	bplin;
 int	palinfo;
 int	shres,svres;
 char	xtra[54];
};

FILE* in, *out;
PCX_header HDR;

int g(void)
{static char cnt=0;
 static int val=0;

 if (cnt) {cnt--; return val;}
 val=getc(in);
 if (val==-1) return -1;
 if ((val&0xc0)==0xc0)
  {cnt=(val&0x3f)-1; return val=getc(in);}
 return val;
};

void put_p(int x, int y, char sym)
{_AL=sym; _DX=y; _CX=x; _AH=0xc; __int__(0x10);
};

int get_p(void)
{static char cnt=0;
 static char sym=0;
 if (!cnt) {cnt=8; sym=g();}
 int i=!!(sym&0x80);
 sym<<=1; cnt--;
 return i;
};

int total=0;

void p(int i)
{if (putc(i,out)==-1) printf("Error %s\n",sys_errlist[errno]);
};


void wr(unsigned cnt)
{if (cnt>=0x7fff) {printf("Too many count (%d)",total); exit(1);}
 if (cnt>=128) {p((cnt>>8)|0x80); p(cnt);  total+=2;}
 else {p(cnt); total++;}
};

unsigned rd(void)
{char c=getc(in);
 total++;
 if (c<0x80) return c;
 total++;
 return ((c<<8)&0x7f00) | getc(in);
};

/*
void wr(unsigned cnt)
{while (cnt>=255) {p(255); p(0); cnt-=255;}
 p(cnt);
};

unsigned rd(void) {return getc(in);}
*/
int unp_p(void)
{static unsigned cnt=0;
 static char col=0;
 while(1)
  {if (!cnt) {col=!col; cnt=rd();}
   if (cnt) {cnt--; break;}}
 return col;
};

void draw(void)
{int x,y,i;
 total=0;
 _AX=0x6; __int__(0x10);
for(y=0;y<HDR.y2;++y)
 for(x=i=0;i<HDR.bplin*8;++i) put_p(x++,y,unp_p());
 getch();
_AX=3; __int__(0x10);
};

main()
{in=fopen(_argv[1],"rb");
 if (!in) {printf("Unable to open file %s\n",_argv[1]); return 1;}
 out=fopen(_argv[2],"wb");
 if (!out) {printf("Unable to create file %s\n",_argv[2]); return 1;}
 fread(&HDR,sizeof(PCX_header),1,in);
 int i, x, y;
 long c=long(HDR.y2+1)*(HDR.x2+1);
x=1; i=get_p();
while(c--)
 {if (i==get_p()) x++;
  else {i=!i; wr(x); x=1;}}
wr(x);
fclose(in); fclose(out);
in=fopen(_argv[2],"rb");
draw();
fclose(in);
};

