
SGENCI:
       DB   01H,23H,45H,67H
       DB   01H,23H,0CDH,0EFH
       DB   01H,23H,45H,67H

PALN:  DB 0FFH,0FEH,0FDH,0FCH,0FBH,0FAH,0F9H,0F8H,0FFH,0F6H,0EDH,0E4H,0DBH
       DB 0D2H,0C9H,0C0H

C_INIT:
       LD   (PAR1),A
       LD   A,HIGH INTRADR
       LD   I,A
       LD   IX,IX_BAS
       LD   HL,VAR1_I
       LD   DE,IX_BAS
       LD   BC,VAR1_S
       LDIR
       LD   A,1
       RST  18H
       LD   A,0C3H
       LD   (SW_DO),A
       LD   (OUT_SW),A
       LD   (SW_CLR),A
       LD   HL,OUT_CH
       LD   (OUT_SW+1),HL
       LD   DE,SG_ENC
       LD   HL,SGENCI
       LD   BC,12
       LDIR
       CALL MODE
       LD   HL,PALN
       CALL SP_AUX1
       CALL CUR_AC
       LD   A,3
       JP   SET_PG

M_INIT: LD      A,3
        RST     18H
        LD      DE,0F800H
        LD      HL,MON_IMG
        LD      BC,MON_SIZE
        LDIR
        LD      HL,CH2
        LD      DE,23H
        LD      B,8
m_i_lp: LD      (HL),0
        ADD     HL,DE
        DJNZ    m_i_lp
IF ROM
        LD      HL,0C000H
        XOR     A
        rst 18h
        LD      D,(HL)
        LD      (HL),55H
        LD      A,8
        rst 18h
        LD      E,(HL)
        LD      (HL),0AAH
        XOR     A
        rst 18h
        LD      A,55H
        CP      (HL)
        EX      AF,AF'
        LD      (HL),D
        LD      A,8
        rst 18h
        LD      (HL),E
        LD      A,3
        RST     18H
        EX      AF,AF'
        RET     Z
        LD      BC,CH1?5
        LD      (CHTBL+2),BC
ENDIF
        RET

CPM_LOAD:
	LD	BC,CPM_SIZE
CPM_L1: PUSH	BC
        CALL    TST_RT
        CALL    _SIGN
        dw      32eh, 101h
IF rom
        dw      0fff4h-0ff72h
ELSE
        dw      0fff4h-0efefh
ENDIF
					ld	hl,0fff4h
.comment @
        EX      DE,HL
        INC     DE
	LD	HL,0FFFEH
	ADD	HL,DE
	SBC	HL,HL			; HL=0 IF ERR, ELSE HL=FFFF
LPL1:	LD	A,D
	XOR	E
	XOR	L
	LD	(ED_BUF),A
	LD	A,(ED_BUF+10)
	ADD	A,D
	DAA
	LD	E,A
	DEC	D
	JR	NZ,LPL1
	XOR	L
	XOR	E
	LD	L,A
@
;	CALL	MS
;	DB 0DH,0AH,'SIGN:',0
;	LD	A,H
;	CALL	HEX2
;	LD	A,L
;	CALL	HEX1
;	CALL	MS
;	DB 0DH,0AH,'TIME:',0
;	LD	A,(RTIME+1)
;	CALL	HEX2
;	LD	A,(RTIME)
;	CALL	HEX1
;	CALL	CRLF

	LD	C,0
	EXX
	POP	BC
	LD      DE,CCP
        LD      HL,CPM_IMG

;	LDIR
;	RET

CPMLLP: LD	A,(HL)
	EXX
	XOR	C
	XOR	L
	LD	C,A
	ADD	HL,HL
	JR	NC,$+3
	INC	HL
	EXX
	LD	(DE),A
	INC	DE
	CPI
	JP	PE,CPMLLP
        RET

SUB_1: 	DI
        POP     HL
	LD	A,3
        RST     18H
	PUSH	AF
	LD	BC,(INTRADR)
	PUSH	BC
        LD      BC,PTST_1
        LD      (INTRADR),BC
        PUSH    HL
        LD      HL,1
	IM	2
	RET

TST_RT: CALL    SUB_1      ; ret HL & RTIME
	EI
	HALT
	ld b,20
	djnz $
	or a
	ei
PTST_L:	INC	HL
	JR	NC,PTST_L
	LD	(RTIME),HL
PTST_E:	DI
	IM	1
        POP     DE
        LD      (INTRADR),DE
	POP	AF
        RST     18H
	EI
	RET

PTST_1: SCF
	RET


SIGN:   CALL    SUB_1      ; DE - const, ret - HL
        ld      hl,1
        EI
	HALT
        nop
__l:    dec     de
        ld a,d
        or e
        jr      nz,__l
LL:     IN      A,(0FEH)
	ADD	A,A
	ADC	HL,HL
        JR      NC,LL
	jr	ptst_e


_sign:  pop     hl        ; call _sign\dw<tur-const>,<nor-const>\dw<add-if-turbo>
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl
        push    de           ; PUSH tur const 
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl           ; DE <- nor const
        ld      c,(hl)
        inc     hl
        ld      b,(hl)       ; BC <- add
        inc     hl
        ex      (sp),hl      ; HL <- tur const
        bit     4,(ix+_rtime+1) ; nz if turbo
        jr      z,sign
        ex      de,hl
	push	bc
        call    sign
	pop	bc
        add     hl,bc
        ret

