/*
#define VER710

#if defined(VER6xx)
#define S_CONST 0116h
#define S_VALUE 3F6Dh

#define S1_DELAY 51
#define S1_CONST_V 40
#define S1_VALUE 1		; lo(value) xor hi(value)

#define R_TIME 0F4Bh

#elif defined(VER7xx)   // vers 7

#define S_CONST 0127h
#define S_VALUE 7FEFh

#define S1_DELAY 51
#define S1_CONST_V 2Ch
#define S1_VALUE 0A3h           ; lo(value) xor hi(value)

#define R_TIME 0F4Bh

#elif defined(VER710)

#define S_CONST 0130h
#define S_VALUE 0BFFEh

#define S1_DELAY 51
#define S1_CONST_V 5Ah
#define S1_VALUE 0C4h           ; lo(value) xor hi(value)

#define R_TIME 0F4Bh

#endif

#ifndef NOPROT
#define S1_CONST S1_CONST_V
#else
#define S1_CONST (s1_c)
#endif
*/

.z80
        cseg
#include "misk.ash"
#include "cio.ash"

BIOS    EQU     0EA00H
CCP     EQU     BIOS-1600H

PRINT   MACRO   A1,A2,A3,A4,A5
IF1
.PRINTX /A1 A2 A3 A4 A5/
ENDIF
        ENDM

#define IX_SHIFT 127

#define IX_BASE IX_BAS+IX_SHIFT

DM     MACRO name, size, com
IF     GEN_MRK
_&name EQU $-IX_BAS-IX_SHIFT
name:  DEFS size
ELSE
 IFNB <com>
       com
 ENDIF
ENDIF
       ENDM

gen_mrk defl    1
       aseg
       ORG  5F40H
IX_BAS:
#include "var1.asm"
#include "dvar1.asm"

print <VarLow1 slot size:> %($-IX_BAS)
print <VarLow1 slot left:> %(6000h-$)

       ORG  7F40H
ED_BUF: DS  128
MAXQUI EQU  10H; KEYBUFFER SIZE
BEGQUI: DS  MAXQUI
print <VarLow2 slot left:> %(8000h-$)

       ORG  0DF40H
#include "VAR2.asm"
print <VarHi1 slot left:> %(0E000h-$)

        cseg
