       or       a
       jp       z,dr_cpm
       out      (0feh),a
       ld       hl,5800h
       ld       de,5801h
       ld       bc,767
       ld       (hl),3fh
       ldir
       ex       af,af'
       ld       hl,sinc_pal
       call     set_pal
       rst      8
       db       16h
       call     tst_cks
       cp       3
       jr       z,tr_ok
       call     disk
       DEFB    "TRDOS   C",0
       jr       c,derr
tr_ok: ex       af,af'
       dec      a
       jr       z,dr_trdos
       dec      a
       jr       z,dr_128
     ; sinc 48
dr_trdos:
       ex       af,af'
       rst      8
       db       14h
       call     disk
       DEFB     "SINCLER C",0
       jp       c,derr
       ex       af,af'
       jp       nz,exit
     ; for trdos
       ld   hl,gotrz
       ld   de,8000h
       ld   bc,10h
       ldir
       ld   bc,0
       push bc
       ld   bc,7ffdh
       ld   a,30h
       push af
       push bc
       ld   bc,0ff7bh
       jp   8000h
gotrz: in   a,(c)
       pop  bc
       pop  af
       out  (c),a
       jp   3d2dh
dr_128:
       rst      8
       db       10h
       call     disk
       DEFB     "SINCLER0C",0
       jp       c,derr
       rst      8
       db       14h
       call     disk
       DEFB     "SINCLER1C",0
       jp       c,derr
       xor      a
       jp       exit0
dr_cpm:ld       a,(ry7)
       or       a
       jr       z,drc512
       rst      8
       db       6h
       call     disk
       DEFB    "CPM128  C",0
       jp       c,derr
       jr       dcl_1
drc512:rst      8
       db       14h
       call     disk
       DEFB    "CPM512  C",0
       jp       c,derr
dcl_1: ld       hl,8000h
       call     disk1
       DB      "CPMCFG  C",0
       jp       nc,exit
       or       a
       jp       z,exit
       jp       derr
