#include <dos.h>
#include <io.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fcntl.h>

char buf[1000];

char gen_gl=0, gen_me=0, chk_dep=0;

void strip(char * fname, int doit=0)
{char n[100],nm[20],*p;
 strcpy(n,fname);
 if (p=strchr(n,'.')) strcpy(p+1,"asm"); else strcat(n,".asm");
 if (!stricmp(n,fname)) {printf("Can't convert file %s to itself\n",n); return;}
 FILE * in=fopen(n,"rt");
 strcpy(nm,n);
 if (!in)
  {if (access(fname,0)) printf("**Error**  Unable to open file %s\n",n);
   else printf("%12s -- already exists\n",fname);
   return;}
 if (chk_dep && !doit && !access(fname,0))
  {struct ftime ftin,ftout; int i;
   if (getftime(fileno(in), &ftin)) {perror("Can't get time"); exit(-1);}
   if ((getftime((i=_open(fname,O_RDONLY)),&ftout) & (_close(i),1)) ||
       *(long*)&ftout>=*(long*)&ftin)
     {printf("%12s -- skipped\n",fname); return;}}
 FILE * out=fopen(fname,"wt");
 if (!out)
  {printf("**Error** Unable to create file %s\n",fname); fclose(in); return;}
 printf("%12s -> %s\n",n,fname);
 int i=0,j,line=0;
 while(!feof(in) && fgets(buf,1000,in))
  {if (!i && !memcmp(buf,"@ME.FORMAT",10)) {i=1; continue;}
   i=1; line++; j=strlen(buf);
   if (buf[j-1]=='\n') buf[--j]=0;
   strcpy(n,buf);
   for(p=n;*p;p++) if (*p>127) *p='.';
   if (gen_me) {char inf=0;
    for(p=n;*p;p++)
     if (inf) {if (*p==inf) inf=0;} else
     switch(*p)
      {case '\"': case '\'': inf=*p; break;
       case ';': *p--=0;}
    for(p--;p>=n && *p==' ';p++) *p=0;
    if (!*n) continue;}
   if (gen_gl) for(p=n;*p;p++)
    {if (*p==';' || *p=='\'' || *p=='\"') {fputs(p,out); break;}
     putc(*p,out);
     if (*p==':') {putc(':',out); if (p[1]==':') p++; else j++;}}
   else fputs(n,out);
   if (gen_me) fprintf(out," ;~L%d~F%s",line,nm);
   putc('\n',out);
   if (!strcmp(p=strupr(strtok(n, " \t")),"INCLUDE") ||
       !strcmp(p,"$INCLUDE"))
     strip(strtok(NULL, " \t"));}
 fputs("\x1a\n",out);
 fclose(in); fclose(out);
};

main()
{if (_argc<=1)
  {puts("Usage: asm2mac <in file> {<options>}\n\
   options are:\n\
     /g - force labels to global;\n\
     /m - generate output for MultiEdit\n\
     /d - check auto-dependencies");
   return 1;}
 char *p,s[79];
 strcpy(s,_argv[1]);
 if (p=strchr(s,'.')) *p=0;
 strcat(s,".mac");
 int i;
 for(i=2;i<_argc;++i)
  if (_argv[i][0]=='/')
   switch(toupper(_argv[i][1]))
    {case 'G': gen_gl=1; break;
     case 'M': gen_me=1; break;
     case 'D': chk_dep=1; break;
    }
 strip(s,1);
};
