#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>

char buf[256], out[256];
int in_p,out_p;
FILE *in, *out_f;
int tab_size=8,out_case=0,pack_f=0;

static char* ps, *pst;
int z80=0;

char* _strtok(char* s1, const char* s2)
{static char buf[256];
 char* p=buf;
 if (!s1) s1=ps;
 while(*s1 && strchr(s2,*s1)) s1++;
 pst=s1;
 while(*s1 && !strchr(s2,*s1)) *p++=*s1++;
 *p=0;
 ps=s1;
 return buf;
};

int getl()
{if (fgets(out,256,in))
  {for(in_p=out_p=0;out[in_p] && out[in_p]!='\n';++in_p,++out_p)
    if (out[in_p]!='\t') buf[out_p]=out[in_p]; else
     {memset(buf+out_p,' ',tab_size-out_p%tab_size);
      out_p+=tab_size-out_p%tab_size-1;}
   buf[out_p]=0;
   out_p=in_p=0;
   return 0;}
 fputs("\x1a\n",out_f);
 return 1;
};

char sp()
{while(buf[in_p]==' ') out[out_p++]=buf[in_p++];
 return buf[in_p];
};

char sk() {return out[out_p++]=buf[in_p++];}

void putl()
{while (sk());
 int i,j,k,ocase=out_case,in_d=0;
 char* p=out;
 while(*p)
  if (!pack_f || *p!=' ')
   {if (ocase) {if (in_d) {if (in_d==*p) in_d=0;} else
     {if (ocase==1) *p=toupper(*p); else *p=tolower(*p);
      if (*p==';') ocase=0; else
      if (*p=='\'' || *p=='\"') in_d=*p;}}
    putc(*p++,out_f);}
  else
   {j=p-out;
    for(i=0;p[i]==' ';++i);
    p+=i;
    k=((i+j)/tab_size)*tab_size;
    if (k>j)
     {i+=j-k; k=(k-j+tab_size-1)/tab_size;
      while(k--) putc('\t',out_f);}
    while(i--) putc(' ',out_f);}
 putc('\n',out_f);
};

struct enc {
 char*  mnem;
 char*  newm;
} mn_s[]={{"MOV","LD\t0R,1R"},{"MVI","LD\t0R,1N"},{"LDAX","LD\tA,(0P)"},
{"STAX","LD\t(0P),A"},{"LDA","LD\tA,(0N)"},{"STA","LD\t(0N),A"},
{"ADD","ADD\tA,0R"},{"SUB","SUB\t0R"},{"ADC","ADC\tA,0R"},{"SBB","SBC\tA,0R"},
{"ADI","ADD\tA,0N"},{"SUI","SUB\t0N"},{"ACI","ADC\tA,0N"},{"SBI","SBC\tA,0N"},
{"INR","INC\t0R"},{"DCR","DEC\t0R"},{"CMA","CPL"},{"RLC","RLCA"},{"DAA","DAA"},
{"RAL","RLA"},{"RRC","RRCA"},{"RAR","RRA"},{"CMC","CCF"},{"STC","SCF"},
{"JMP","JP\t0N"},{"HLT","HALT"},{"ANA","AND\t0R"},{"ORA","OR\t0R"},
//{"CALL","CALL\t0N"},{"NOP","NOP"},{"EI","EI"},{"DI","DI"},{"RET","RET"},
{"XRA","XOR\t0R"},{"CMP","CP\t0R"},{"ANI","AND\t0N"},{"ORI","OR\t0N"},
{"XRI","XOR\t0N"},{"CPI","CP\t0N"},{"IN","IN\tA,(0N)"},{"OUT","OUT\t(0N),A"},
{"LXI","LD\t0P,1N"},{"LHLD","LD\tHL,(0N)"},{"SHLD","LD\t(0N),HL"},
{"SPHL","LD\tSP,HL"},{"XCHG","EX\tDE,HL"},{"XTHL","EX\t(SP),HL"},
{"PCHL","JP\t(HL)"},{"RZ","RET\tZ"},{"RNZ","RET\tNZ"},{"RC","RET\tC"},
{"RNC","RET\tNC"},{"RPE","RET\tPE"},{"RPO","RET\tPO"},{"RP","RET\tP"},
{"RM","RET\tM"},{"PUSH","PUSH\t0P"},{"POP","POP\t0P"},{"DAD","ADD\tHL,0P"},
{"INX","INC\t0P"},{"DCX","DEC\t0P"},{"JZ","JP\tZ,0N"},{"JNZ","JP\tNZ,0N"},
{"JC","JP\tC,0N"},{"JNC","JP\tNC,0N"},{"JPO","JP\tPO,0N"},{"JPE","JP\tPE,0N"},
{"JP","JP\tP,0N"},{"JM","JP\tM,0N"},{"CZ","CALL\tZ,0N"},{"CNZ","CALL\tNZ,0N"},
{"CC","CALL\tC,0N"},{"CNC","CALL\tNC,0N"},{"CPO","CALL\tPO,0N"},
{"CPE","CALL\tPE,0N"},{"CP","CALL\tP,0N"},{"CM","CALL\tM,0N"},
{"RST","RST\t0T"}};

char *regp[]={"hl","bc","de","af","sp"};
char regs[]="hbdps";

void conv_reg(char* par, char spec, int ucase)
{switch(spec)
  {case 'N': strcpy(out+out_p,par); out_p+=strlen(par); break;
   case 'T': out_p+=sprintf(out+out_p,ucase?"%XH":"%xh",(*par-'0')*8); break;
   case 'R':
    if (tolower(*par)=='m') {strcpy(out+out_p,ucase?"(HL)":"(hl)"); out_p+=4;}
    else {strcpy(out+out_p,par); out_p+=strlen(par);}
    break;
   case 'P': char *p=strchr(regs,tolower(*par));
    p=p?regp[p-regs]:"??";
    strcpy(out+out_p,p);
    if (ucase) strupr(out+out_p);
    out_p+=strlen(p);
    break;
  }
};

int p_start=0;

void convert(char lit, enc& m)
{char p1[100], p2[100],*p;
 int start=in_p,o_case;
 if (strchr(m.newm,'0')) {strcpy(p1,_strtok(NULL," ,;")); p_start=pst-buf;}
 if (strchr(m.newm,'1')) strcpy(p2,_strtok(NULL," ,;"));
 in_p=ps-buf;
 while(buf[in_p]==' ') in_p++;
 if (!p_start) p_start=start+tab_size;
 // determ case
 o_case=isupper(lit);  // 1 - up case
 // mnem print
 for(p=m.newm;*p;++p)
  switch(*p)
   {case '\t': while(out_p<p_start) out[out_p++]=' '; break;
    case '0': case '1': conv_reg(*p=='0'?p1:p2,p[1],o_case); p++; break;
    default:  out[out_p++]=*p;}
 while(out_p<in_p) out[out_p++]=' ';
};

int pars_line()
{if (getl()) return 0;
 if (sp()!=';' && buf[in_p])
  {if (!memicmp(buf+in_p,".z80",4)) z80=1; else
   if (!memicmp(buf+in_p,".8080",5)) {z80=0; buf[in_p]=';';} else
   if (!z80)
    {int i=in_p;
     while(buf[i] && (isalnum(buf[i]) || strchr("@#$&_?.!",buf[i]))) i++;
     if (buf[i]==':')
      {while(buf[i]==':') i++; sp();
       while(in_p<i) out[out_p++]=buf[in_p++];}
     sp();
     if (isalpha(buf[in_p]))    // may be mnem
      {char* p=_strtok(buf+in_p," ,");
       for(i=0;i<sizeof(mn_s)/sizeof(mn_s[0]);++i)
        if (!stricmp(p,mn_s[i].mnem))
         {convert(p[0],mn_s[i]); break;}
      }
    }
  }
 putl();
 return 1;
};

cdecl main()
{puts("i8080 to z80 assembler converter.   Copyright (c) 1992 by XVR - Product");
 if (_argc<2) {puts(
                "Usage: i2z <in file[.asm]> [<out file[.mac]>] {<options>}\n"
                "   Options are:\n"
                "    /t=<tab size>       set tab size\n"
                "    /p                  pack tab on output\n"
                "    /u                  use mnemonics in upper case\n"
                "    /l                  or in low case"); return 1;}
 int i=2;
 char str[256],*p;
 strcpy(str,_argv[1]);
 if (!(p=strrchr(str,'.'))) strcpy(p=str+strlen(str),".asm");
 if (!(in=fopen(str,"rt")))
  {printf("Unable to open input file %s (%s)\n",str,sys_errlist[errno]);
   return 1;}
 if (_argc<3 || _argv[2][0]=='/' || _argv[2][0]=='-') strcpy(p,".mac");
 else {strcpy(str,_argv[2]); i=3; if (!strrchr(str,'.')) strcat(str,".mac");}
 if (!(out_f=fopen(str,"wt")))
  {printf("Unable to create open file %s (%s)\n",str,sys_errlist[errno]);
   return 1;}
 errno=0;
 for(;i<_argc;++i)
  if (_argv[i][0]=='-'||_argv[i][0]=='/')
   switch(tolower(_argv[i][1]))
    {case 't': tab_size=atoi(_argv[i]+3); if (!tab_size) tab_size=8; break;
     case 'p': pack_f=1; break;
     case 'u': out_case=1; break;
     case 'l': out_case=-1; break;}

 while(pars_line());
 fclose(in); fclose(out_f);
 if (errno) {printf("Error: %s\n",sys_errlist[errno]); return 1;}
 return 0;
};
