.z80

#include "common.ash"
#include "draw.ash"

start:: ;pop     hl
        ;ld      (old_sp),sp
        ;ld      sp,0C000h
        ;push    hl
        ld      hl,page_d
        call    s_pgs
        ld      hl,0
        call    _cl
        ld      hl,0C9FBh
        ld      (38h),hl
        im      1
        ld      hl,2000h
        call    _cl
        ld      hl,4000h
        call    _cl
        ld      hl,6000h
_cl:    ld      d,h
        ld      e,l
        inc     de
        ld      bc,7999
        ld      (hl),0
        ldir
        ret

exit::  ld      hl,page_s
s_pgs:  push    af
        ld      a,SYS_P0
        call    do_s_pg
        ld      a,SYS_P6
        call    do_s_pg
        pop     af
        ret

do_s_pg:ld      bc,177h
        out     (c),a
        push    hl
        ld      de,40h
        ld      bc,0ff7h
page_l1:outi
        ld      a,b
        add     a,e
        ld      b,a
        jp      p,page_l1
        pop     hl
        ret

;old_sp: ds      2
page_s: db      18h, 7ah
page_d: db      7ah, 7eh

end
