.z80
Mget_bit  macro
          endm

;-------------------------------
;  draw picture

draw::  push    de
        exx
        pop     hl
        ld      b,0ffh
        ld      de,0
        exx
ldraw:  push    hl
        ld      e,c
ildraw: inc     c
ild1:   dec     c
        jr      z,ildone
        call    get_byte
        jr      z,ilbits
        ld      d,a
        sub     c
        neg
        ld      c,a
        call    fill
        jr      ildraw

ilbits: ld      c,1
ilb1:   ld      a,d
        or      e
        call    z,_get_b
        dec     de
        rrc     b
        rl      c
        jr      nc,ilb1
        ld      a,c
	exx
        ld      (hl),a
        call    next
        jr      ild1

ildone: pop     hl
        ld      c,e
        ld      de,40
        add     hl,de
        djnz    ldraw
        ret

;----------------------
; aux proc's for draw:
;     get one bit (CF)
_get_b: ld      a,b
        cpl
        ld      b,a
        ld      e,(hl)
        inc     hl
        ld      d,0
        bit     7,e
        ret     z
        ld      d,e
        res     7,d
        ld      e,(hl)
        inc     hl
        ret

;------------------------
; get the some of bytes

get_byte: ld      a,c
        exx
        ex      af,af'
        ld      a,d
        or      e
        call    z,_get_b
        ld      a,e
        and     0f8h
        or      d
        ret     z
        push    de
        srl     d
        rr      e
        srl     d
        rr      e
        srl     d
        ld      c,0ffh
        jr      nz,gbt_1
        rr      e
        ld      c,e
gbt_1:  pop     de
        ex      af,af'
        cp      c
        jr      c,gbt_2
        ld      a,c
gbt_2:  push    hl
        ld      l,a
        ld      h,0
        add     hl,hl
        add     hl,hl
        add     hl,hl
        ex      de,hl
        sbc     hl,de
        ex      de,hl
        pop     hl
        ex      af,af'
        ld      a,b
        exx
        ld      (hl),a
        ex      af,af'
        or      a
        ret

;-----------------------------
; evaluate next screen position

next:   ld   a,20h
        xor  h
        ld   h,a
        and  20h
        ret  nz
        inc  hl
        ret

;--------------------------
; fill one line on screen

fill:   push bc
        push de
        push hl                 ; start-1 for 2
        ld   c,d
        srl  c
        ld   b,0
        push bc                 ; len for 2
        jr   nc,$+3
        inc  c
        ld   d,h
        ld   e,l
        inc  de
        dec  c
        jr   z,f_2
        ldir
f_2:    jr c,f_1
        ex de,hl
f_1:    call c,next
        pop  bc
        ex   (sp),hl
        inc  c
        dec  c
        jr   z,f_3
        ld   d,(hl)
        call next
        ld   (hl),d
        ld   d,h
        ld   e,l
        inc  de
        dec  c
        jr   z,f_3
        ldir
f_3:    pop  hl
        pop  de
        pop  bc
        ret

