;ENCODING ATM PICTURE
.Z80
BUFF	EQU 0C000H
mstr_beg equ  4000h+40*8*23
COLOR   EQU 8
B?COL	EQU 1AH
S?COL	EQU 2CH
I?F	EQU 37H
F?B	EQU 78H
B?G	EQU 0C1H
G?R	EQU 0CAH
R?F	EQU 97H
SEL?C	EQU 0E3H
NOR?C	EQU 0F5H	; !!!! DEPEND ON CONSTANT IN MESSAGE !!!!

        jr      run
_load:  out     (0feh),a
        rst 28h
l_name: ds 9
        db 0
        ex      af,af'
        ld      a,1
        out     (0beh),a
        ret
gotrz:  in   a,(7bh)
        out  (0feh),a
        pop     af
        out     (c),a
        jp   3d2dh

load:   ld      hl,5800h
        ld      de,5801h
        ld      bc,75fh
        ld      (hl),9
        ldir
        pop     hl
        ld      de,l_name
        ld      bc,9
        ldir
        push    hl
        ld      a,1
        ld      hl,0c000h
        call    _load
        ex      af,af'
        ret

run:    jr      nz,is_ru5
        xor     a
        ld      (fru7+1),a
is_ru5: ld   hl,pal
        rst 18h
        call    pict
        xor  a
        call SEL1
.comment @
				rst 8
				db 0ch
				call 33h
				ld de,mstr_beg
				call 	hex
				push de
				rst 8
				db 8
				call 33h
				pop de
				call hex
@
IN?LP:  rst 30h
        cp 3
        JR z,EXIT
        add a,a
        sub 3
        neg
        ld c,a
	CALL SEL
	JR IN?LP

EXIT:
	ld a,(csel)
        or a
        jp z,l_cpm
        rst 8
        db 0eh
        call 33h        ; tst_cks
        cp 3
        jr z,tr_ok
        call load
        DB "TRDOS   C"
        jr  c,derr
tr_ok:  ld      a,(csel)
        sub     2
        jr      z,s128
        rst 8
        db 0ch
        call load
        DB "SINCLER C"
        jr c,derr
        ld      a,(csel)
        cp      1
        jp      nz,23h
        call 3
        rst 18h
        rst  8
        db   0
        ld   bc,0
        push bc
        ld   a,30h
        push af
        ld   bc,7ffdh
        jp   gotrz
s128:   rst      8
        db       8
        call     load
        DEFB     "SINCLER0C"
        jr       c,derr
        rst      8
        db       0ch
        call     load
        DEFB     "SINCLER1C"
        jp       nc,2bh
derr:   push     af
        call     pict
_derr:  ld       hl,mstr_beg
        ld      de,sv_buf
        ld      bc,40*8
        ldir
        ld       hl,mstr_beg+2000h
        ld      bc,40*8
        ldir
        LD  DE,mstr_beg+10
        pop     af
        LD      HL,Mderr
        jr      nz,_er_
        ld      hl,Mnofile
_er_:   CALL PRN
        rst     30h
        ld      de,mstr_beg
        ld      hl,sv_buf
        ld      bc,40*8
        ldir
        ld      de,mstr_beg+2000h
        ld      bc,40*8
        ldir
        call    sel
        jp      in?lp

l_cpm: ld       a,(fru7+1)
       or       a
       jr       z,drc512
       rst      8
       db       6h
       ld       hl,0c000h
       rst      28h
       DEFB    "CPM128  C",0
       jr       c,cerr
       jr       dcl_1
drc512:rst      8
       db       0ch
       ld       hl,0c000h
       rst      28h
       DEFB    "CPM512  C",0
       jr       c,cerr
dcl_1: ld       hl,sv_buf
       rst      28h
       DB      "CPMCFG  C",0
       jr       c,no_cfg
       rst      8
       db       1
       ld       hl,sv_buf
       ld       de,0ff40h
       ld       bc,192
       ldir
crun:  LD  DE,mstr_beg+10
       LD      HL,Mins
       CALL PRN
       rst     30h
       call     3
       rst      18h
       rst      8
       db       0
       in       a,(7bh)
       rst 0
no_cfg:or       a
       jr       z,crun
cerr:  push     af
       jp       _derr

;-----------------------------------
; draw picture
;
pict:   rst 8
        db 5
        LD Bc,200*256+80
	LD HL,BUFF
	LD DE,ATM
	CALL DRAW

        LD HL,BUFF
	LD A,0FCH
	CALL S4
	LD HL,BUFF+8231
	LD A,3FH
	CALL S4

	LD HL,BUFF
	LD C,10
VLP::	PUSH HL
	LD B,200
	LD DE,40
_VLP::   SET 7,(HL)
	SET 6,(HL)
	ADD HL,DE
	DJNZ _VLP
	POP HL
	LD  E,4
	ADD HL,DE
	DEC C
	JR NZ,VLP

	LD HL,BUFF
	LD A,8
	LD DE,1000
	CALL S3

	LD   HL,BUFF
	LD   A,2
	LD   DE,40
	CALL S3
	LD   HL,BUFF+7920
	LD   A,2
	CALL S3

	LD  HL,BUFF+1773
	LD  DE,M1
        LD  Bc,36*256+28
	CALL DRAW

	LD  HL,BUFF+1572+2000H
	CALL DR_C
	DB  0FFH,0C0H,0CFH,0
	LD  A,0CCH
	LD  B,112
	CALL S41
	CALL DR_C
	DB  0CFH,0C0H,0FFH,0
	LD  HL,BUFF+1587
	CALL DR_C
	DB  0FFH,3,0F3H,0
	LD  A,33H
	LD  B,112
	CALL S41
	CALL DR_C
	DB  0F3H,3,0FFH,0
	LD HL,BUFF+1573
	LD BC,51CH
	LD A,0
	CALL FIL
	LD HL,BUFF+1573
	LD BC,11CH
	LD A,0FFH
	CALL FIL
	LD HL,BUFF+1653
	LD BC,11CH
	LD A,0FFH
	CALL FIL
	LD HL,BUFF+6093
	LD BC,51CH
	LD A,0
	CALL FIL
	LD HL,BUFF+6173
	LD BC,11CH
	LD A,0FFH
	CALL FIL
	LD HL,BUFF+6253
	LD BC,11CH
	LD A,0FFH
	CALL FIL

	LD HL,BUFF+3213
	LD BC,481CH
	XOR A
	CALL FIL

        rst 8
        db 1


        LD   HL,0C000H
	LD   DE,0C001H
	LD   BC,7999
	LD   (HL),COLOR
	LDIR
	LD   HL,0E000H
	LD   DE,0E001H
	LD   BC,7999
	LD   (HL),COLOR
	LDIR

	LD   HL,BUFF+1773
	LD   BC,241CH
	LD   A,I?F
	CALL FIL
;	LD   HL,BUFF+3373
;	LD   BC,401CH
;	LD   A,I?F
;	CALL FIL
	LD   HL,BUFF+1818
	LD   BC,612H
	LD   A,R?F
	CALL FIL
	LD   HL,BUFF+2066
	LD   BC,1D01H
	LD   A,R?F
	CALL FIL
	LD   HL,BUFF+2184+2000H
	LD   BC,1A01H
	LD   A,F?B
	CALL FIL
	LD   HL,BUFF+2185
	LD   BC,1A01H
	LD   A,B?G
	CALL FIL
	LD   HL,BUFF+2185+2000H
	LD   BC,1A01H
	LD   A,G?R
	CALL FIL

	LD  HL,BUFF+1572+2000H
	LD  A,B?COL
	LD  B,118
	CALL S41
	LD  HL,BUFF+1587
	LD  A,B?COL
	LD  B,118
	CALL S41
	LD HL,BUFF+1573
	LD BC,51CH
	LD A,B?COL
	CALL FIL
	LD HL,BUFF+6093
	LD BC,51CH
	LD A,B?COL
	CALL FIL

	LD HL,BUFF+6293+2000H
	LD BC,81CH
	LD A,S?COL
	CALL FIL
	LD HL,BUFF+1907+2000H
	LD BC,7602H
	LD A,S?COL
	CALL FIL

	LD HL,BUFF+3213
	LD BC,481CH
	LD A,NOR?C
	CALL FIL

        rst 8
        db 5

	LD  DE,BUFF+3537+2000H
	LD  HL,MS1
	CALL PRN
	LD  DE,BUFF+4175+2000H
	LD  HL,MS2
	CALL PRN
	LD  DE,BUFF+4814
	LD  HL,MS3
	CALL PRN
	LD  DE,BUFF+5454+2000H
	LD  HL,MS4
	CALL PRN
	LD  A,1
	OUT (0bEH),A
        ret

SEL:	PUSH BC
	LD B,0
CSEL	EQU $-1
	LD A,NOR?C
	CALL HI_LIT
	POP BC
	LD A,(CSEL)
	ADD A,C
	AND 3
SEL1:	LD (CSEL),A
        cp      2
fru7:   jr      z,sel
sel_2:  LD B,A
	LD A,SEL?C
HI_LIT:	LD HL,BUFF+3453+2000H
	LD DE,640
	INC B
	DEC B
	JR Z,HI?BRK
HI?L:	ADD HL,DE
	DJNZ HI?L
HI?BRK: PUSH AF
        rst 8
        db 1
	POP AF
	LD BC,0B1AH
FIL::	LD (F_VAL),A
	SRL C
	LD A,C
	JR NC,$+3
	INC C
	PUSH HL
	EXX
	LD C,A
	LD B,0FFH
	POP HL
        CALL next
	EXX
F_LP:	INC C
	DEC C
	JR Z,BRK
	PUSH HL
	PUSH BC
	LD (HL),0
F_VAL   EQU $-1
	LD D,H
	LD E,L
	INC DE
	LD B,0
	DEC C
	JR Z,SKP
	LDIR
SKP:	POP BC
	POP HL
BRK:	LD DE,40
	ADD HL,DE
	EXX
	DJNZ F_LP
	RET

DR_C:	POP DE
	LD BC,40
D_L:	LD A,(DE)
	INC DE
	OR A
	JR Z,D_EXT
	LD (HL),A
	ADD HL,BC
	JR D_L
D_EXT:	PUSH DE
	RET

S1::	LD D,H
	LD E,L
	INC DE
	LD (HL),0FFH
	LD BC,39
	LDIR
	RET

S2::	PUSH HL
	CALL S1
	POP  HL
	PUSH HL
	SET  5,H
	CALL S1
	POP  HL
	RET

S3::     PUSH DE
	CALL S2
	POP  DE
	ADD  HL,DE
	DEC  A
	JR   NZ,S3
	RET

S4::     LD   B,200
S41::	LD   DE,40
S4L::	LD   (HL),A
	ADD  HL,DE
	DJNZ S4L
	RET

PAL:    DB 8,6,0,37H,27H,27H,10H,0EH,0,26H,25H,37H,1bh,0,3AH,0

MS1:	DB "C  P  /  M",0FFH
MS2:	DB "T R - D O S   4 8",0FFH
MS3:	DB "S P E C T R U M   1 2 8",0FFH
MS4:	DB "S P E C T R U M   4 8",0FFH
Mderr:  DB "Disk reading error",0ffh
Mnofile:DB "No system file",0ffh
Mins:   DB "Insert CP/M disk and press ENTER",0ffh

INCLUDE UNPCK.MAC

ATM::
INCLUDE MZATM.MAC

M1::
INCLUDE MM1.MAC

SG_BEG::
INCLUDE ZS.MAC

INCLUDE ZC.MAC
.comment @
; tests
HEX:
        PUSH    AF
        RRCA
        RRCA
        RRCA
        RRCA
        CALL    DHEX
        POP     AF

;
; TYPE ONE HEX DIGIT
;
DHEX:   AND     0FH
        ADD     A,90H
        DAA
        ADC     A,40H
        DAA
        call    PUT_CH
	ex de,hl
	ret
@
sv_buf:

; call 3     pallet in hl
; rst  8     set page <db>
; call 0bh   set page <a>
; rst  10h   restart
; call 13h   disk err
; rst  18h   set palet from hl
; call 1bh   set palet (for sinc mode)
; rst  20h   read sector
; jp   23h   sincler run (with pal)
; rst  28h   read file <name>
; jp   2bh   sinc128 run
; rst  30h   read key
      ;enter  3
      ;up     2
      ;dn     1
; call 33h   tesh checksum

END

