#ifndef __CIO__
#define __CIO__

;------------------------------
; Errors codes for C_STAT
;
Cs_unkno  equ   0ffh    ; unknown function
Cs_ersec  equ   80h     ; wrong sequence
Cs_unprn  equ   81h     ; unprintable char in sequence
Cs_nodrv  equ   82h     ; driver not installed
Cs_erpar  equ   83h     ; wrong parameters
Cs_nomod  equ   84h     ; screen mode does not exist
        ; text mode errors
CsT_over  equ   1       ; can't write over

_TF_curatr equ 0        ; Cursor is flex attrib


;---------------------------------
; The some bit flags layout

; FLAG'S BIT LAYOUT

_RU5   EQU  0
_C_STA EQU  1
_FLEX_C EQU 2
_USER  EQU  3
_CAPS  EQU  4
_RUS   EQU  5
_K_SS  EQU  6
_K_CS  EQU  7

; FLAG1'S BIT LAYOUT
_OVER  EQU  0
_TRANS EQU  1
_FASTR EQU  2
_BREAK EQU  3
_ROLL  EQU  4
_INTOF EQU  5

#endif
