#include "allvars.ash"
#include "ddef.asm"

#pragma local

;   init
VAR1_I:
GEN_MRK defl 0
.XLIST
#include "VAR1.asm"
.LIST

VAR1_S     EQU      $-VAR1_I

PALN::
          db 0ffh, 0feh, 0fdh, 0fch, 0efh, 0eeh, 0edh, 0ech
          db 0ffh, 0deh, 0bdh, 09ch, 06fh, 04eh, 02dh, 00ch


C_INIT:: ex af,af'
       ld   a,3
       rst  18h
       ex af,af'
       LD   (PAR1),A
       LD   A,HIGH INTRADR##
       LD   I,A
       LD   IX,IX_BASE
       LD   HL,VAR1_I
       LD   DE,IX_BAS
       LD   BC,VAR1_S
       LDIR
       LD   A,1
       RST  18H
       LD   A,0C3H
       LD   (OUT_SW),A
       LD   HL,OUT_CH##
       LD   (OUT_SW+1),HL
       CALL MODE##
       CALL SP_DEF##

       LD   A,3
       rst  18h
       ret

M_INIT::LD      A,3
        RST     18H
        LD      DE,0F800H
        LD      HL,MON_IMG##
        LD      BC,MON_SIZE##
        LDIR

        ld      hl,bss_start##
        ld      de,bss_start+1
        ld      bc,bss_lng##-1
        ld      (hl),0
        ldir
        RET

@@
;---------------------------------------
; Memory sizer

#define buf     PAR1

swp:    ex      (sp),hl
        ld      de,buf+3
        ld      bc,3
        ldir
        ex      (sp),hl
        ld      de,-1
	ld	a,3Fh
	call	@@s1
	ld	a,1Fh
	call	@@s1
	ld	a,7
@@s1:   rst     18h
        call    buf+3
        inc     hl
        ret
@@

@@read: call    swp
            ld      a,(de)
            ld      (hl),a
            ret
        ret
@@write:call    swp
            ld      a,(hl)
            ld      (de),a
            ret
        ret

Mtest:  ld      hl,buf+6
        call    @@read
        ld      hl,@@src
        call    @@write
        ld      hl,buf
        call    @@read
        ld      hl,buf+6
        call    @@write

        call    @@tst
@@src:  db      49h, 92h, 24h
	set	_RU5,(ix+_flag)
	dec	c
	ld	de,m_128
	ret	z
	res	_RU5,(ix+_flag)
	dec	c
	ld	de,m_512
	ret	z
	ld	de,m_1024
	dec	c
	ret	z
/*
        dw      m_1024
        call    @@tst
        db      92h, 92h, 24h
        dw      m_512
        set     _RU5,(_FLAG+ix)
        call    @@tst
        db      24h, 24h, 24h
        dw      m_128
*/
        call    prn##
        db      'fault. (',0
	ld	a,(buf)
	call	phex##
	ld	a,(buf+1)
	call	phex
	ld	a,(buf+2)
	call	phex1##
	call	prn
	db	')',0dh,0ah,0
        di
        halt
/*
@@tst:  pop     hl
        ld      de,buf
        ld      bc,3FFh
@@lp:   ld      a,(de)
        cp      (hl)
	inc	hl
	inc	de
        jr      z,@@1
        inc     c
@@1:    djnz    @@lp
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl
        inc     c
        ret	z
        jp      (hl)
*/

@@tst:  pop     hl
        ld      de,buf
        ld      bc,300h
@@lp:   ld      a,(de)
        cp      (hl)
	inc	hl
	inc	de
        jr      nz,@@2
        inc     c
	jr	@@1
@@2:	ld	c,0
@@1:    djnz    @@lp
        jp      (hl)

m_128:  db      3
        dw      384
        db      '128',0
m_512:  db      1Bh
        dw      3456
        db      '512',0
m_1024: db      3Bh
        dw      7552
        db      '1024',0

mem_size::
        call    prn
        db      'Memory ',0
        call    Mtest
	ld	a,3
	rst	18h
        ex      de,hl
        ld      a,(hl)
        inc     hl
        ld      (CHed##+DCYLN),a
        ld      (CHed##+DTRACK),a
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl
        ld      (CHed##+DBLDR),de
        call    prn
        db      'size is ',0
        call    prn_hl##
        call    prn
        db      'k.',0dh,0ah,0
        ret
#undef buf
@@


CPM_LOAD::
        LD      BC,CPM_SIZE##
CPM_L1::;PUSH    BC
;        CALL    TST_RT
/*
        ld      de,S_CONST
        CALL    SIGN
	ld a,h
	call phex##
	ld a,l
	call phex
	ld a,(Hsign)
	call phex##


#ifdef NOPROT
        ld      hl,S_VALUE
#else
        ld      de,S_CONST
        CALL    SIGN
#endif
	LD	C,0
	EXX
	POP	BC
*/
	LD      DE,CCP
        LD      HL,CPM_IMG##

       LDIR
       RET
/*
CPMLLP: LD	A,(HL)
	EXX
	XOR	C
	XOR	L
	LD	C,A
	ADD	HL,HL
	JR	NC,$+3
	INC	HL
	EXX
	LD	(DE),A
	INC	DE
	CPI
	JP	PE,CPMLLP
        RET

SUB_1: 	DI
        POP     HL
	LD	A,3
        RST     18H
	PUSH	AF
	LD	BC,(INTRADR)
	PUSH	BC
        LD      BC,PTST_1
        LD      (INTRADR),BC
        PUSH    HL
        LD      HL,1
	IM	2

zon::   ld      bc,0FD77h
zon_bc::ld	a,(sys_p)
	ld	(tmp_w),a
	and	77h
	or	40h
	ld	(sys_p),a
        out     (c),a
	xor	a
	in	a,(0FEh)
        ret
@@
zoff::	ld	a,(tmp_w)
	and	7Fh
	ld	(sys_p),a
	call	set_sys
	xor	a
@@1:	dec	a
	jr	nz,@@1
	set	7,(ix+_sys_p)
*/
set_sys::ld      a,(sys_p)
set_asys::
        ld      bc,0FD77h
        out     (c),a
        RET
@@

PTST_1::di
        SCF
	RET

/*
TST_RT:: CALL    SUB_1      ; ret HL & RTIME
	EI
	HALT
	ld b,20
	djnz $
	or a
	ei
PTST_L:	INC	HL
	JR	NC,PTST_L
	LD	(RTIME),HL
PTST_E:	DI
	IM	1
        POP     DE
        LD      (INTRADR),DE
	POP	AF
        RST     18H
        EI
	jr	zoff




SIGN::  CALL    SUB_1      ; DE - const, ret - HL
	xor	a
;	in	a,(0FEh)
        EI
	HALT
        nop
__l:    dec     de
        ld a,d
        or e
        jr      nz,__l
LL:     IN      A,(0FEH)
	and	20h
	add	a,0E0h
	ADC	HL,HL
        JR      NC,LL
        jr      ptst_e


sign1:: ld      hl,1
__2:    dec     de
        ld a,d
        or e
        jr      nz,__2
LL1:    IN      A,(0FEH)
	and	20h
	add	a,0E0h
	ADC	HL,HL
        JR      NC,LL1
        jr      zoff
*/
h_init::

rcall   macro   addr
        local   raddr
        ld      sp,raddr
        jp      addr
raddr:  dw      $+2
        endm

        ld  bc,077h
        ld  a,2
        out (c),a
        im      1
        di
        rcall   pg_set
        ld bc,77h
        ld a,6h ;!!!
        out (c),a
        rcall    pg_set

        ld      sp,SYS_SP##
        ld a,10h
        out (c),a
        ld a,6h ;!!!
        ld bc,177h
        out (c),a

          ld hl,dsk_tab
          ld de,610h ;!!!
          ld c,77h
          ld  a,8
          out (0ffh),a
dsk_1:    ld  a,(hl)
          inc hl
          out (0ffh),a
          ld  b,41h
          out (c),d
          or  8
          out (0ffh),a
          ld  b,1
          out (c),d
          dec e
          jr  nz,dsk_1


          ld  bc,4177h
          ld  a,6h ;!!!
          out (c),a

          ld a,0ffh
          out (0ffh),a
          ld hl,0C000h
          ld a,(hl)
          cp 0C3h
          jr nz,_ent
          xor a
ch_lp:    add a,(hl)
          adc a,0
          inc hl
          bit 7,h
          jr  nz,ch_lp
          dec a
          jr  nz,_ent
          ld  a,0AAh
          dec hl
          cp  (hl)
          jr  nz,_ent
          cpl
          dec hl
          cp  (hl)
          jp  z,0C000h
_ent:     jp  entry##

pg_set:   ld hl,page_d
          ld de,40h
page_l2:  ld bc,0ff7h
page_l1:  outi
          ld a,b
          add a,e
          ld b,a
          jr nc,page_l1
          ld bc,7ffdh
          ld a,d
          xor 10h
          ld d,a
          out (c),a
          jr nz,page_l2
          ret

page_d:   db 7fh, 7bh, 7dh, 7ch, 18h, 7ah, 7dh, 60h  ; 31 page

dsk_tab:  ;db  01h,  11h,  21h,  31h,  31h,  41h,  51h,  61h
          ;db 0b1h, 0d1h, 0c1h, 0e1h, 0f1h, 0f1h,  01h,  11h

          db 0f1h, 0e1h, 0d1h, 0c1h, 0c1h, 0b1h, 0a1h,  91h
          db 041h, 021h, 031h, 011h, 001h, 001h, 0f1h, 0e1h
end

