.AUTODEPEND
.PATH.rel=W

NOPROT =
VE =

!ifdef NOPROT
AOPT = -DNOPROT
!endif
!ifdef VE
AOPT = $(AOPT) -DVE31
!endif
!ifdef TEST
AOPT = $(AOPT) -DTEST
!endif

.drv.rel:
        app $< W/$&.mac -M -I\atm\title\new  $(APP_OPT) $(AOPT)
	cd W
	z m80 $&,$&=$&
	cd ..
        m80err W/$&.prn $(APP_OPT) >> meerr.tmp

.asm.rel:
        app $< W/$&.mac -M -I\atm\title\new  $(APP_OPT) $(AOPT)
	cd W
	z m80 $&,$&=$&
	cd ..
        m80err W/$&.prn $(APP_OPT) >> meerr.tmp

all:	rom.lod
	@echo All done

rom.img:  W\rbios.com stub
          copy W\rbios.com/b rom.img
	  setsz rom.img 4000h
          ccnt rom.img 3ffeh 71h E

ALL_RELS =      rbios.rel       \
                conio.rel       \
                scankey.rel     \
                textio.rel      \
                hex.rel         \
                disk.rel        \
                fdcwd.rel       \
                eddrv.rel       \
                hddrv.rel       \
                config.rel      \
		bs.rel		\
                init.rel

!ifdef VE
!ifdef TEST
ALL_RELS = $(ALL_RELS) kbdum.rel cidum.rel tester.rel
!else
ALL_RELS = $(ALL_RELS) ve31.rel ci.rel
#ALL_RELS = $(ALL_RELS) ve31int.rel ci.rel
!endif
!else
ALL_RELS = $(ALL_RELS) kb.rel ci.rel
!endif


W\rbios.com: $(ALL_RELS)
        xlink /B0 /mrom.map /srom.sym /LW /b @&&|
$(ALL_RELS)
|

bs.rel: bios.rel
        xlink W\bios
        copy cpm60.img/b+W\bios.com/b W\bios.img
#        enc W\bios.img W\bios.enc bffeH
	abs2rel b=cpm_img s=cpm_size W\bios.img W\bs.rel


stub:   title.com #W\keyb.com
        copy /b tr_dosr.img stub
        wr "#stub" 805h: @title.com[:2043.] 31FDh: @title.com[2043.]
	ccnt stub 3fffh 1 n

rom.lod:    rom.img
        copy /b s128_1p.img+stub rom_0.img
        copy /b s128_0p.img+rom.img rom_1.img
	copy /b rom_0.img + rom_1.img rom.lod
        trw rom_0.img
        trw rom_1.img

