#include "allvars.ash"

        aseg
        org     8000h

Rtime_W: ds      2
Sig1_W:  ds      2
Sig2_W:  ds      2

Sig1_v:  ds	2

Sig1_b:  ds      1+4*256
Sig2_b:  ds      1+4*256

        cseg

TESTER:
        call    sp_def##
        CALL    TST_RT##
        ld      hl,(rtime)
       ld   de,-R_TIME
       add  hl,de
       ld   de,-5
       add  hl,de
       jr   nc,__2
       ld       hl,(Rtime_W)
       inc      hl
       ld       (Rtime_W),hl
__2:
        ld      a,(Hsign)
        cp      S1_VALUE
        jr      z,__3
        ld      hl,(Sig2_W)
        inc     hl
        ld      (Sig2_W),hl
__3:
        ld      de,S_CONST
        CALL    SIGN##
	ld	(Sig1_v),hl
;jr __3
        ld      de,S_VALUE
        or      a
        sbc     hl,de
        ret     z
        ld      hl,(Sig1_W)
        inc     hl
        ld      (Sig1_W),hl
        RET

TST_LOOP:: ld	hl,8000h
	ld	de,8001h
	ld	(hl),0
        ld      bc,1000h
	ldir

        ld      hl,0
loop:   push    hl
        CALL    TESTER
        call    prn##
        db      1bh,'HPass: ',0
        pop     hl
        push    hl
        call    phexw##
        call    prn
        db      ', Wrongs: Rtime-',0
        ld      hl,(Rtime_W)
        call    phexw
        call    prn
        db      ', Sign1-',0
        ld      hl,(Sig1_W)
        call    phexw
	call	prn
        db      ', Sign2-',0
        ld      hl,(Sig2_W)
        call    phexw

        ld      de,(Sig1_v)
        call    Shw_1
        ld      de,(Hsign)
	ld	d,0
        call    Shw_2

	pop	hl
	inc	hl
        jr      loop

_find:  ld      l,(iy)
        ld      h,(iy+1)
        or      a
        sbc     hl,de
        ret     z
        inc     c
        inc     iy
        inc     iy
        inc     iy
        inc     iy
        djnz    _find
        scf
        ret

lfind:  push    iy
        ld      c,0
        ld      b,(iy)
        inc     iy
        inc     b
        dec     b
        scf
        call    nz,_find
        pop     hl
        ret     nc
        inc     (hl)
        jr      nz,lfok
        dec     (hl)
        ret
lfok:   ld      (iy),e
        ld      (iy+1),d
        ld      (iy+2),0
        ld      (iy+3),0
        ret

find:   call    lfind
        inc     (iy+2)
        jr      nz,fsh1
        inc     (iy+3)
fsh1:   ld      a,c
        ld      b,c
        and     0Fh
        add     a,' ' +2
        ld      c,a
        ld      a,b
        rrca
        and     18h
        ret

Shw_1:  ld      iy,Sig1_b
        call    find
        ld      b,a
        rrc     b
        add     a,b
        call    gotoxy
        ld      a,(iy+1)
        call    phex1##
en:     ld      a,(iy+0)
        call    phex1
        ld      a,'-'
        rst     20h
        ld      a,(iy+3)
        call    phex1
        ld      a,(iy+2)
        jp      phex1
Shw_2:  ld      iy,Sig2_b
        call    find
        add     a,48
        call    gotoxy
        jr      en

gotoxy: ld      b,a
        call    prn
        db      1Bh,'Y',0
        ld      a,c
        rst     20h
        ld      a,b
        add     a,' '
        rst     20h
        ret

        end
