; load block. In: IX->buf, A-00 is header, FF is data block
;                 DE-length, C'-tape port
;             Out:CF-o'k, else error or break
.z80
LD_bytes::
          INC D
          EX AF,AF'
          DEC D
          DI
          LD A,0FH
          exx
          OUT (C),A
          exx
          IN A,(0FEH)
          RRA
          AND 20H
          OR 2H
          LD C,A
          CP A
LD_break: RET NZ
LD_start: CALL LD_edge1
          JR NC,LD_break
          LD HL,415H
lp31:     DJNZ lp31
          DEC HL
          LD A,H
          OR L
          JR NZ,lp31
          CALL LdEdge2
          JR NC,LD_break
LD_leade: LD B,9CH
          CALL LdEdge2
          JR NC,LD_break
          LD A,0C6H
          CP B
          JR NC,LD_start
          INC H
          JR NZ,LD_leade
LD_sync:  LD B,0C9H
          CALL LD_edge1
          JR NC,LD_break
          LD A,B
          CP 0D4H
          JR NC,LD_sync
          CALL LD_edge1
          RET NC
          LD A,C
          XOR 3H
          LD C,A
          LD H,0H
          LD B,0B0H
          JR LD_marke

LD_loop:  EX AF,AF'
          JR NZ,LD_flag
          LD (IX+0),L
          INC IX
          JR LD_dec

LD_flag:  RL C
          XOR L
          ld  a,0ffh
          RET NZ
          LD A,C
          RRA
          LD C,A
          INC DE
LD_dec:   DEC DE
          EX AF,AF'
          LD B,0B2H
LD_marke: LD L,1H
LD_8bits: CALL LdEdge2
          RET NC
          LD A,0CBH
          CP B
          RL L
          LD B,0B0H
          JP NC,LD_8bits
          LD A,H
          XOR L
          LD H,A
          LD A,D
          OR E
          JR NZ,LD_loop
          LD A,H
          CP 1H
          RET

LdEdge2:  CALL LD_edge1
          RET NC
LD_edge1: LD A,16H
lp32:     DEC A
          JR NZ,lp32
          AND A
LD_sampl: INC B
          RET Z
          LD A,7FH
          IN A,(0FEH)
          RRA
          RET NC
          XOR C
          AND 20H
          JR Z,LD_sampl
          LD A,C
          CPL
          LD C,A
          AND 7H
          OR 8H
          exx
          OUT (C),A
          exx
          SCF
          RET
end
