#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <alloc.h>
#include <fcntl.h>
#include <ctype.h>

struct tr_header {
 char     name[8];
 char     ext;
 unsigned start;
 unsigned len;
 char     zero;
 char     sects;
 unsigned checksum;
};

void cnt_chk(tr_header& hdr)
{int i,j;
 for(i=j=0;i<15;++i) j+=((char*)&hdr)[i]*0x101+i;
 hdr.checksum=j;
};

int f;
void rd(void* buf, unsigned size)
{if (_read(f,buf,size)!=size)
  {puts("Error reading file"); _close(f); exit(1);}
};

int tab(int pos)
{return (!pos||pos==7||pos==12||pos==21||pos>=44);}

inline int _isalnum(char c) {return c=='_' || isalnum(c);}

void do_hex(char* &str, FILE * out)
{str++;
 if (!isdigit(*str)) putc('0',out);
 while(isxdigit(*str)) putc(*str++,out);
 putc('H',out);
};

void wrt6(char* &str, FILE * out)
{int i=0;
 while (_isalnum(*str))
  {if (i++<6) putc(*str,out);
   str++;}
};

void wrtout(char* str, FILE * out)
{if (*str==';') {fprintf(out,"%s\n",str); return;}
 if (*str=='*')
  {if (toupper(str[1])=='F')
    fprintf(out,"INCLUDE %s.mac\n",strchr(str,':')+1);
   return;}
 // may be mark
 if (!*str) {putc('\n',out); return;}
 if (*str!=' ')
  {wrt6(str,out);
   char* p=str;
   while (*p==' ') p++;
   if (!memicmp(p,"MAC",3))
    {*p=0; fputs(str,out); fputs("MACRO\n",out); return;} else
   if (memicmp(p,"EQU",3))
    {putc(':',out); if (*(int*)str=='  ') str++;}}
 else
  {char* p=str; while (*p==' ') p++;
   if (!*p) {putc('\n',out); return;}}
 int in_q=0;
 while(*str)
  if (in_q)
   {putc(*str,out); if (strchr("\"\'",*str++)) in_q=0;}
  else
   {if (strchr("\"\'",*str)) {putc(*str++,out); in_q=1;} else
    if (_isalnum(*str)) wrt6(str,out); else
    if (*str=='#') do_hex(str,out); else
    if (*str==';') {fprintf(out,"%s\n",str); return;}
    else putc(*str++,out);}
 putc('\n',out);
};

main()
{char outstr[256];
 char * outp;
 if (_argc<2) {puts("Usage: dp2mac <in file> [<out file>]"); return 0;}
 tr_header hdr;
 f=_open(_argv[1],O_RDONLY);
 if (f==-1) {printf("Unable to open input file %s\n",_argv[1]); return 1;}
 rd(&hdr,sizeof(tr_header));
 char* p=(char*)malloc(hdr.len);
 if (!p) {puts("No memory"); _close(f); return 1;}
 rd(p,hdr.len); _close(f);
 FILE* o;
 if (_argc<3) o=stdout; else
 if (!(o=fopen(_argv[2],"wt")))
  {printf("Unable to create output file %s\n",_argv[2]); return 1;}
 int ol;
 while(hdr.len)
  {p+=2; hdr.len-=2;
   if (hdr.len==0||hdr.len==-1) break;
   ol=0; outp=outstr;
   while(*p!=0xd)
    {if (!hdr.len) break;
     if (*p=='\t') do *outp++=' '; while(!tab(++ol));
     else {*outp++=*p; ++ol;}
     --hdr.len; ++p;}
   *outp=0;
   wrtout(outstr,o);
   if (!hdr.len) break; p++; --hdr.len;}
 fclose(o); free(p);
};
