#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <alloc.h>
#include <fcntl.h>

struct tr_header {
 char     name[8];
 char     ext;
 unsigned start;
 unsigned len;
 char     zero;
 char     sects;
 unsigned checksum;
};

void cnt_chk(tr_header& hdr)
{int i,j;
 for(i=j=0;i<15;++i) j+=((char*)&hdr)[i]*0x101+i;
 hdr.checksum=j;
};

int f;
void rd(void* buf, unsigned size)
{if (_read(f,buf,size)!=size)
  {puts("Error reading file"); _close(f); exit(1);}
};

int tab(int pos)
{return (!pos||pos==7||pos==12||pos==21||pos>=44);}

main()
{if (_argc<2) {puts("Usage: dpr <in file> [<out file>]"); return 0;}
 tr_header hdr;
 f=_open(_argv[1],O_RDONLY);
 if (f==-1) {printf("Unable to open input file %s\n",_argv[1]); return 1;}
 rd(&hdr,sizeof(tr_header));
 char* p=(char*)malloc(hdr.len);
 if (!p) {puts("No memory"); _close(f); return 1;}
 rd(p,hdr.len); _close(f);
 FILE* o;
 if (_argc<3) o=stdout; else
 if (!(o=fopen(_argv[2],"wt")))
  {printf("Unable to create output file %s\n",_argv[2]); return 1;}
 int ol;
 while(hdr.len)
  {fprintf(o,"%5u ",*(int*)p); p+=2; hdr.len-=2;
   if (hdr.len==0||hdr.len==-1) break;
   ol=0;
   while(*p!=0xd)
    {if (!hdr.len) break;
     if (*p=='\t') do putc(' ',o); while(!tab(++ol));
     else {putc(*p,o); ++ol;}
     --hdr.len; ++p;}
   putc('\n',o); if (!hdr.len) break; p++; --hdr.len;}
 fclose(o); free(p);
};
