#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

FILE* in, *out;
int Lcnt=24;

typedef unsigned uint;

char outb[1024];
char* fil;
struct file_ref {
 uint  faddr; // or file num
 char  id[1];
} *f_root;
char* in_files[100];

void EXIT(char* str, int e=1)
{if (str) if (e<0) {perror(str); e=-e;} else puts(str);
 if (fil) free(fil);
 if (f_root) free(f_root);
 for(int i=0;in_files[i]&&i<100;i++) free(in_files[i]);
 exit(e);
}

char prog[]={
#include "prog.img"
};
char prog1[]={
#include "prog1.img"
};

char enc_tab[32]={
0x41,0x42,0x57,0x47,0x44,0x45,0x56,0x5a,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,
0x52,0x53,0x54,0x55,0x46,0x48,0x43,0x5e,0x5b,0x5d,0x5f,0x59,0x58,0x5c,0x40,0x51};
char escs[]={1,0,0,0,0,0,2,0,0,0,0,0,16,1,1,1,0,0,9,0,0,2,0,4,1,2,1,1,2,2,2,
             0,16,1,2,16};

void P(void* p, int len=0)
{errno=0;
 if (!len) len=strlen((char*)p);
 if(fwrite(p,1,len,out)!=len) EXIT("Error writing file",-1);
}

inline char nsp(char p) {return p&&!strchr(" \t\r\n",p);}

char cvt_str(char* str, char* outs=outb)
{char islat=1,wrn=0;
 int c;
 while(1) switch (c=*str++)
  {case 0xa:  if (!islat) {islat=1; *outs++=14;} *(int*)outs=0xa; return wrn;
   case 0x1a: case 0: if (!islat) *outs++=14; *outs=0; return wrn;
   case 12:   *outs++=-1; break;
   case 0x1b: do_esc:
      *outs++=0x1b; *outs++=c=*str++;
      if ((c=='^' && *str=='O') || strchr("Lc",c)) wrn|=2;
      if ((c-='@')<0 || c>=sizeof(escs))
       {printf("Unknown ESC sequience (<ESC>");
        if ((c+='@')>=' ') putchar(c); else printf("<0x%02X>",c);
        printf(") encounted\n"); c=0;} else
      if (c=='N'-'@') // pallet set
       {*outs++=c=*str++;
        switch(c)
         {case 'T': c=48; break; // total pallet set
          case 'R': c=0; break;  // default restore
          default:  c=3;}}
      else c=escs[c];
      while(c--) *outs++=*str++;
      break;
   case '\\':
      switch(toupper(c=*str++))
       {case '^': switch(c=*str++)                // controll
         {case 'N': goto do_lat;
          case 'O': goto do_rus;
          case '[': goto do_esc;
          case 'M': goto do_cr;
          default: *outs++=c-'@';} break;
        case 'E': goto do_esc;                 // esc
        case 'R': goto do_rus;                 // russian
        case 'L': goto do_lat;                 // lat
        case 'C': *(int*)outs=0x1b+'F'*256;    // color set
                  outs+=2; *outs++=*str++; *outs++=*str++; break;
        default: goto do_def;}
      break;
   case 0xd:  do_cr:  if (!islat) {islat=1; *outs++=14;} *outs++=0xd; break;
   case 14:   do_lat: islat=1; *outs++=14; break;
   case 15:   do_rus: islat=0; *outs++=15; break;
   default:   do_def:
    if (c<'@') *outs++=c; else
    if (c<0x80) {if (!islat) {islat=1; *outs++=14;} *outs++=c;} else
    if (c<0xb0 || c>=0xe0 && c<0xf0)
     {if (islat) {islat=0; *outs++=15;}
      if (c<0xa0) *outs++=enc_tab[c-0x80]; else
      if (c<0xb0) *outs++=enc_tab[c-0xa0]+0x20; else
      *outs++=enc_tab[c-0xe0+0x10]+0x20;}
     else {wrn|=1; *outs++=' ';}}
}

char* fnd_ext(char* name)
{char* p1=name+strlen(name)-1;
 while(!strchr(":\\.",*p1) && p1>=name) p1--;
 return *p1=='.'?p1:NULL;
};

char* att_ext(char* name, char* ext,int cond=0)
{static char s[80];
 char *ep=stpcpy(s,name),*p1=fnd_ext(s);
 if (!p1) p1=ep; else
 if (cond) return s;
 strcpy(p1,ext);
 return s;
};

void make1(int gen_com)
{char buf[1024],err=0;
 if (gen_com) P(prog,sizeof(prog));
 while(!feof(in) && fgets(buf,1023,in))
  {err|=cvt_str(buf);
   if (fputs(outb,out)==EOF) EXIT("Error writing file",-1);}
 if (fputc('\x1a',out)==EOF) EXIT("Error writing file",-1);
 fclose(in);
}

long fpos;    // position of help topics
int maxl=0,ids=0;

void pars_inp()
{P(prog1,sizeof(prog1));
 long l=filelength(fileno(in));
 if (l>0xfff0) {puts("Config file too long"); exit(1);}
 fil=new char[l+1];
 char *p;
 if (!fil) {puts("No memory"); exit(1);}
 errno=0;
 if (fread(fil,1,l,in)!=l) EXIT("Can't read config file",-1);
 fclose(in);
 fil[l]=0;
 int cnt;
 for(p=fil;(long)p!=1;p=strchr(p,0xa)+1)
  if (nsp(*p))
   {ids++; for(cnt=0;nsp(*p);p++,cnt++); if (maxl<cnt) maxl=cnt;}
 maxl+=3;
 l=0x100+sizeof(prog1)+4+ids*maxl;
 P(&maxl,1); P(&ids,1); P(&l,2);     // header: db max_id_leng, num_of_id
 f_root=(file_ref*)malloc(ids*maxl); //         dw start_of_null_section
 if (!f_root) EXIT("No memory");
 file_ref* fr=f_root;
 int  last_f=-1;
 for(p=fil;(long)p!=1;p=strchr(p,0xa)+1)
  if (nsp(*p))
    {for(cnt=0;nsp(*p);p++,cnt++) fr->id[cnt]=toupper(*p); // copy ID
     if (*p) p++; fr->id[cnt]=0; fr->id[maxl-3]=0;
     if (*p=='^')                                          // add new src file
      {for(cnt=0; nsp(p[cnt]); ++cnt);
       char* s=new char[cnt]; if (!s) EXIT("No memory");
       memcpy(s,p+1,cnt-1); s[cnt-1]=0;  memset(p,' ',cnt);
       in_files[++last_f]=s; p+=cnt;} else
     if (last_f<0) EXIT("Undefined help file");
     fr->faddr=last_f;                                  // set src file num
     (char*)fr+=maxl;}
 fpos=ftell(out);
 if (fseek(out,ids*maxl,SEEK_CUR)) EXIT("Seek error",-1);
}

void gen_topics()
{char* p,cnt,c;
 for(p=fil;(long)p!=1;p=strchr(p,0xa)+1)
  switch(*p)
   {case 0: p=""; break;                        // end of line
    case '\n': case '\r': P("\r\n"); break;     // spare line
    case '\t': case ' ': p+=2; cnt=0;
       if (p[-1]=='*') goto id_skip;  goto p_line;
    default: for(cnt=0;nsp(p[cnt]);++cnt);
       c=p[cnt]; p[cnt]=0; cvt_str(p); P(outb); // out ID
       p+=cnt+1; if (!c) {P("\r\n"); break;}
       id_skip: while(*p && !nsp(*p)) p++;      // find start of string
       if (*p=='\\') p++;  // may mark start of line by '\' sign
       while(cnt<maxl) {P(" "); cnt++;}
       p_line: cvt_str(p); P(outb);}            // put rest of line
}

file_ref* find(char* topic, int hfile, int line)
{file_ref* fr=f_root;
 for(int i=0;i<ids;++i,(char*)fr+=maxl)
  if (!stricmp(fr->id,topic) && !fr->id[maxl-3] && fr->faddr==hfile)
   {fr->id[maxl-3]=1; return fr;}
 printf("Topic '%s' (file: %s, line: %3d) undefined\n",
         topic,in_files[hfile],line);
 return NULL;
}

char eof_was=1;

int gen_help(int hfile)
{FILE* in;
 int process=1;
 int lcnt=Lcnt-1;
 if (hfile>=100 || !in_files[hfile]) return 0;
 if (!(in=fopen(in_files[hfile],"rb")))
  {printf("Unable to open help file %s\n",in_files[hfile]);
   return 1;}
 char buf[1024]; int line=0; int skip=1;
 while(!feof(in))
  {if (!(line&127)) printf("%-20s  Line: %d\r",in_files[hfile],line+1);
   errno=0; line++;
   if (!fgets(buf,1023,in))
    {if (errno) perror("Can't read help file"); break;}
   if (!strcmp(buf,"\\-\xD\xA")) process=0; else               // turn off paging
   if (!strcmp(buf,"\\+\xD\xA")) {process=1; lcnt=Lcnt;} else  // turn on paging
   if (!strcmp(buf,"\xC\xD\xA") && process) {lcnt=Lcnt; P("\xFF");} else
   if (*(int*)buf=='\\T') // topic
    {char* c;
     process=1;
     lcnt=Lcnt-1;
     if (!eof_was) {P("\x1a"); eof_was=1;}
     for(c=buf+3;nsp(*c);++c); *c=0;
     file_ref* p=find(buf+3,hfile,line);
     if (!(skip=!p)) p->faddr=0x100+ftell(out);}
   else if (!skip)
    {cvt_str(buf); P(outb); eof_was=0;
     if (process && !--lcnt) {lcnt=Lcnt; P("\xFF");}}
  }
 fclose(in);
 return 1;
}

void wr_topics()
{file_ref* fr=f_root;
 for(int i=0;i<ids;++i,(char*)fr+=maxl)
  {if (!fr->id[maxl-3])
    {printf("No reference for topic '%s'\n",fr->id);
     fr->faddr=0;}
   fr->id[maxl-3]=0;}
 fseek(out,fpos,SEEK_SET);
 P(f_root,maxl*ids);
}

void make2()
{pars_inp();     // make topic list
 gen_topics();   // generate topic lists
 P("\x1a");
 for(int i=0;gen_help(i);++i);
 if (!eof_was) P("\x1a");
 wr_topics();
};

main()
{char use2=0,*p;
 if (_argc==1) {puts("Usage: mhelp [@]<in file> [-<str num>] [<out file>]"); return 1;}
 p=_argv[1];
 if (p[0]=='@') {p++; use2=1;}
 if (!(in=fopen(p=att_ext(p,".hlp",1),"rb")))
  {printf("Unable to open input file %s\n",p); return 1;}
 char *p1=NULL;
 for(int i=2;i<_argc;++i)
  if (_argv[i][0]=='-' || _argv[i][0]=='/') Lcnt=atoi(_argv[i]+1); else
  p1=att_ext(_argv[i],".com",1);
 if (!p1) p1=att_ext(p,".com");
 if (!(out=fopen(p1,"wb")))
  {printf("Unable to create output file %s\n",p1); return 1;}
 if (use2) make2(); else make1(!stricmp(fnd_ext(p1),".com"));
 fclose(out);
 EXIT(NULL,0);
}
