#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <alloc.h>
#include <fcntl.h>

typedef struct {
 char     name[8];
 char     ext;
 unsigned start;
 unsigned len;
 char     zero;
 char     sects;
 unsigned checksum;
} tr_header;

int f;
void rd(void* buf, unsigned size)
{if (_read(f,buf,size)!=size)
  {puts("Error reading file"); _close(f); exit(1);}
};

main()
{int o; char* p;
 tr_header hdr;
 if (_argc<3) {puts("Usage: trd <in file> <out file>"); return 0;}
 f=_open(_argv[1],O_RDONLY);
 if (f==-1) {printf("Unable to open input file %s\n",_argv[1]); return 1;}
 rd(&hdr,sizeof(tr_header));
 p=(char*)malloc(hdr.len);
 if (!p) {puts("No memory"); _close(f); return 1;}
 rd(p,hdr.len); _close(f);
 if (!(o=_creat(_argv[2],0)))
  {printf("Unable to create output file %s\n",_argv[2]); return 1;}
 if (_write(o,p,hdr.len)!=hdr.len)
  {puts("Error writing file"); _close(o); return 1;}
 _close(o); free(p);
 return 0;
};
