#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <dos.h>
#include <alloc.h>
#include <fcntl.h>

struct tr_header {
 char     name[8];
 char     ext;
 unsigned start;
 unsigned len;
 char     zero;
 char     sects;
 unsigned checksum;
};

void cnt_chk(tr_header& hdr)
{int i,j;
 for(i=j=0;i<15;++i) j+=((char*)&hdr)[i]*0x101+i;
 hdr.checksum=j;
};

int f;
void rd(void* buf, unsigned size)
{if (_read(f,buf,size)!=size)
  {puts("Error reading file"); _close(f); exit(1);}
};

void wr(void* buf, unsigned size)
{if (_write(f,buf,size)!=size)
  {puts("Error writing file"); _close(f);}
};

main()
{if (_argc<2) {puts("Usage: trw <code file>"); return 1;}
 tr_header hdr;
 char* p1;
 f=_open(_argv[1],O_RDONLY);
 if (f==-1) {printf("Unable to open input file %s\n",_argv[1]); return 1;}
 memset(hdr.name,' ',8);
 memcpy(hdr.name,strupr(_argv[1]),
        (p1=strchr(_argv[1],'.'))?p1-_argv[1]:strlen(_argv[1]));
 hdr.ext='C';
 hdr.start=0;
 hdr.sects=((hdr.len=filelength(f))+255)>>8;
 hdr.zero=0;
 cnt_chk(hdr);
 char* p=(char*)malloc(hdr.len);
 if (!p) {puts("No memory"); _close(f); return 1;}
 rd(p,hdr.len); _close(f);
 if (p1) strcpy(p1,".$"); else strcat(_argv[1],".$");
 f=_creat(_argv[1],0);
 if (f==-1) {printf("Unable to create output file %s\n",_argv[1]);
             free(p); return 1;}
 wr(&hdr,sizeof(hdr));
 wr(p,hdr.sects<<8);
 _close(f);
};
