.z80
_t_diff::
        ex      (sp),hl
        ld      a,(time)
        ld      b,a
        sub     (hl)
        inc     hl
        cp      (hl)
        ccf
        jr      nc,_1
        dec     hl
        ld      (hl),b
        inc     hl
_1:     inc     hl
        ex      (sp),hl
        ret

_t_sw:: ex      (sp),hl
        ld      a,(timem)
        cp      (hl)
        inc     hl
        ccf
        ex      (sp),hl
        ret

time::  db      0
timem:: db      0

add_hl_a:: add  a,l
        ld     l,a
        ret    nc
        inc    h
        ret

seed:   dw      1234h

rand::  ld      hl,(seed)
        ld      a,h
        xor     l
        add     hl,hl
        and     99h
        jp      pe,r_1
        inc     hl
r_1:    ld      (seed),hl
        ld      b,8
r_2:    rr      h
        adc     a,a
        djnz    r_2
        xor     l
        ret

_sw::   ex      (sp),hl
        push    de
        push    bc
        ld      e,(hl)
        inc     hl
        ld      d,(hl)
        inc     hl

;        di
 ;       ldi
  ;      ldi
   ;     ei

;.comment @
        ld      c,(hl)
        inc     hl
        ld      b,(hl)
        inc     hl
        ld      (_sw1),de
        ld      (0),bc
_sw1    equ     $-2
;@

        pop     bc
        pop     de
        ex      (sp),hl
        ret

_p_cnt::ex      (sp),ix
        push    de
        ld      e,(ix)
        ld      d,(ix+1)
        dec     de
        ld      a,d
        or      e
        jr      nz,_p_done
        ld      e,(ix+2)
        ld      d,(ix+3)
_p_done:ld      (ix),e
        ld      (ix+1),d
        inc     ix
        inc     ix
        inc     ix
        inc     ix
        pop     de
        ex      (sp),ix
        ret

end
