#ifndef __DRAW__
#define __DRAW__


;-----------------------------
; Publics
scr_img    equ  8A0h           ; Addr after screen + 1 empty line
FON_char   equ  ' '
FON_attr   equ  0

im_x       equ  0              ; Image struct fields shifts
im_y       equ  1
im_dx      equ  2
im_dy      equ  3
im_shft    equ  4

#define    IM_X      (iy+im_x)
#define    IM_Y      (iy+im_y)
#define    IM_DX     (iy+im_dx)
#define    IM_DY     (iy+im_dy)
#define    IM_SHFT   (iy+im_shft)

#define IM(x,y,dx,dy,page) db x,y,dx,dy,page*20h

#ifndef MAIN

;-----------------------------
; Evaluate start of screen image
; in: DE-y&x, out: HL-addr (AF,DE destroyed)
        extrn ev_img
;---------------------------------
; Draw rectangle (DE-y&x, BC-dy&dx)
        extrn dr_scr
;---------------------------------
; Roll image (iy=> Image struct, ret: CF-image cuted)
        ;extrn up_roll_im
        ;extrn dn_roll_im

;------------------------------
; Draw image (IY->image)
        extrn upd

;------------------------------
; Clear image (IY->image, A-char/attr, CF-clear attr)
        extrn clr

;--------------------------------
; Put 1 char&attr (DE-coor, BC-char&attr, IY->image)
        extrn put

;--------------------------------
; Put string (IY->image&coor)
        ; call put_str
        ; db DX,DY, color, string..., 0

#endif

#endif
