#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

struct _Sline {
 char len,shift;
} Sline[6];

int cur_sline, max_sline;

inline _Sline& nxt()
{_Sline &S=Sline[cur_sline++];
 if (cur_sline>=max_sline) cur_sline=0;
 return S;
}

FILE* out;

void _p(char c)
{if (fputc(c,out)!=EOF) return;
 perror("Can't write");
 exit(1);
}

char p_ch;

void p(char c)
{asm {mov al,c; rol al,1; xor al,93h; xor al,p_ch}
 _p(_AL); p_ch=c;
}

char enc_tab[32]={
0xC1,0xC2,0xD7,0xC7,0xC4,0xC5,0xD6,0xDa,0xC9,0xCa,0xCb,0xCc,0xCd,0xCe,0xCf,0xD0,
0xD2,0xD3,0xD4,0xD5,0xC6,0xC8,0xC3,0xDe,0xDb,0xDd,0xDf,0xD9,0xD8,0xDc,0xC0,0xD1};

char enc(char c)
{if (c<0x80) return c;
 if (c<0xA0) return enc_tab[c-0x80];
 if (c<0xB0) return enc_tab[c-0xA0]+0x20;
 if (c<0xE0) return c-0x30;
 if (c<0xF0) return enc_tab[c-0xD0]+0x20;
 return c-0x40;
}

void ol(char* l)
{for(;*l;l++)
  if (*l==' ')
   {for(char *c=l;*c==' ';++c);
    if (c-l>2) {p(1); _p(c-l); l=c-1;}
    else p(3);}
  else if (*l<' ') {printf("Invalid char %02X\n",*l); exit(1);}
  else p(enc(*l));
}

void out_line(char* l)
{int i=strlen(l);
 int y=cur_sline<<6;
 _Sline &S=nxt();
 int x=(80-i)/2;
 if (i<S.len)
  {p(2); _p(S.shift+y);
   if (x-S.shift) {p(1); _p(x-S.shift);}
   ol(l);
   if (S.shift+S.len-x-i) {p(1); _p(S.shift+S.len-x-i);}}
 else
  {p(2); _p(x+y); ol(l);}
 S.len=i; S.shift=x;
}

main()
{FILE* in=NULL;
 if (_argc<3) {puts("Usage: tgen <input> <output> [-<lines>]"); return 1;}
 for(int i=1;i<_argc;++i)
  if (_argv[i][0]=='-' || _argv[i][0]=='/')
    max_sline=atoi(_argv[i]+1);
  else if (!in) in=fopen(_argv[i],"rt");
  else out=fopen(_argv[i],"wb");
 if (!in || !out) {puts("Where files?"); return 1;}
 if (max_sline>6) {puts("No more then 6 lines alowed!"); return 1;}
 if (!max_sline) max_sline=3;
 char buf[90];
 while(fgets(buf,90,in))
  {i=strlen(buf); if (buf[i-1]=='\n') buf[--i]=0;
   if (i>80) {puts("Line too long, truncated"); buf[80]=0;}
   out_line(buf);}
 while(cur_sline) out_line("");
 for(i=0;i<max_sline;++i)
  if (Sline[i].len)
   {for(i=0;i<max_sline;++i) out_line("");
    break;}
 p(0);
 fclose(in); fclose(out);
}
